<?php
namespace Importacao\Logic\Bases\ModeloImportacao\References;

use \Importacao\Logic\Bases\ModeloImportacao\References\Reference;
use \Importacao\Logic\Bases\ModeloImportacao\References\ValorCampo;
use \Importacao\Logic\Util\Util;

class Label implements Reference
{

	const FIXED_VALUE = "/\#\\$\w+\#/";

	public function getRegularExpression() 
	{
		return self::FIXED_VALUE;
	}

	public function getValorReferencia($nomeTabela, $nomeColuna, $metaDado, $valorFixo, 
									   $entityContainer, $linhaDados = null, $fixedFields = null)
	{
		$dadoColuna = $this->getValue($metaDado, $linhaDados);

		if ($dadoColuna == null || $dadoColuna == "") {
			$dadoColuna = "null";
		}

        return $dadoColuna;
	}

	private function getValue($metaDado, $linhaDados) 
	{
		preg_match(self::FIXED_VALUE, $metaDado, $result);
		$nomeColuna = str_replace(array("$", "#"), "", $result[0]);

		foreach ($linhaDados as $key => $value) {
			if (strtoupper(Util::removeCaracteresInvalidos($key)) === $nomeColuna) {
                $metaDado = str_replace($result[0], $value, $metaDado);
			}
		}

        return $metaDado;
	}

}